% NUMODE: ex:springpend
% evolution of spring pendulum
%

% Right hand side in Cartesian coordinates
Hq = @(q) ((norm(q)-1)*q/norm(q) + [0;1]);
Hp = @(p) (p);

f = @(y) [-Hq(y(3:4));Hp(y(1:2))];

% Right hand side in Polar coordinates


% initial data in Cartesian coordinates
p0 = [0;0];
q0 = [cos(pi/6);-sin(pi/6)];

% initial data in Polar coordinates


% timestep
h = 0.3;

% initial values
P = p0;
Q = q0+0.5*h*p0;

% energy


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ANIMATION

k = 3;
spt = 1/(4*k)+1/(2*k)*(0:2*k-1);
spv = [[0,spt,1];[0,0.1*sin(2*k*pi*spt),0]];

figsv = figure('name','Spring Pendulum','position',[0 0 1600 800]);
subplot(1,2,1);
t = 0;

for i=1:1000
  subplot(1,2,1); q = Q; plotspring;
%  subplot(1,2,2); q = [PQ(1)*cos(PQ(2)) -PQ(1)*sin(PQ(2))]; plotspring;
  
  % symplectic Euler, Cartesian coordinates
  P = P - h*Hq(Q);
  Q = Q + h*Hp(P);
  
  % symplectic Euler, Polar coordinates
  

  t = t+h;
end

[maxEn minEn]

